//Game.h
//Copyright Justin (Merwin) Heiner /1997
//Not Marshall Harnish this time (Even though he's helping me)
//But not much :)

#ifndef CGAME_H
#define CGAME_H

#include <afxwin.h>	//Standard MFC include
#include "dx.h"

class CGame {
public:
	CGame();  //Constructor
	~CGame();  //Destructor
	int Fight(CDX *m_DX); //fight scene
	void SetVariables(); //temporary!
	int CheckMonsterHit(CDX *m_DX);  //handles the monster hits on the main screen
	void KeyHandle(UINT nChar, int UserStatus);  //Handles what the user does, since VC is too damn stupid to do it itself
    int ChangeCurrentTile(char *CurrentTileSet, int SelectedTile, CPoint);   //changes what the current selected tile is (in the editor)
	int ChangeMapTile(CPoint ClickPT, int SelectedTile);  //changes a tile on the map (in the editor)
	int LoadMap(char *Filename);  //Loads the Map
	int CreateNewMap(char *Filename);  //creates a new map
	int SaveEditorMap(char *Filename);  //Saves the Map
	int LoadMapTiles(char *Filename, CDX *m_DX);  //Loads the map tiles onto the tile surface
	int DisplayTinyLogo(char *Filename, int x, int y, CDX *m_DX); //Displays the tiny logo anywhere on the screen.
	int RedrawMap(CDX *m_DX);  //Redraws the Map Screen
	int RedrawEditor(CDX *m_DX);  //Redraws the Editor Screen
	int StretchNE(char *Filename, CDX *m_DX);  //stretches a bitmap North East
	int FadeOut(char *Filename, CDX *m_DX);  //Fades a bmp out
	int FadeIn(char *Filename, CDX *m_DX);  //Fades a bmp in
	int FadeOutHalf(char *Filename, CDX *m_DX);  //Fades a bmp out from 50%
	int FadeInHalf(char *Filename, CDX *m_DX);  //Fades a bmp in to 50%
	int FadeInTwist(char *Filename, CDX *m_DX);  //Fades in with a twist

	int MidStride;  //Checks if character is in midstride :)  for animation
	int RecentHit;  //checks if you've been hit by a monster lately (when walking around on the main map)
	int RandomHit;  //specifies exactly HOW often you get attacked.
//	int FirstMapLoad; //specifies if the map is being loaded for the first time or not.

private:
protected:
	struct MapSizeInfo {  //size of the map..
		short int x;  //how big the map is in X and Y
		short int y;
		short int StartX;  //Starting X and Y of the map
		short int StartY;
		short int StartDir;  //which dir the user is facing
	};
	MapSizeInfo MapSize;



	//Comment about UserInfo
	//The user is located at (User.x+10) (User.y+7)
	struct UserInfo {  //THE USER!!@@(*^#(%*&
		int x;   //X location of the map
		int y;   //Y location of the map
		unsigned int dir; //The direction that user is facing
		int hp;  //Hit points
		int mp;  //Magic points
	};
	UserInfo User;
	
	struct MapInfo {  //Map Tiles and Flags
		short int tile;  //
		short int flag;
	};
	MapInfo Map[1000][1000];
};
#endif
